//AC130-Script by LurchiDerLurch ac130_rot_camera
disableSerialization;

private ["_display","_logic","_xM","_yM","_difh","_difv","_360View","_angles","_logic","_setCirclePosition","_setSphericPosition","_ac130_cam_target"];

waitUntil {sleep 0.1; (LDL_ac130_active)};

_360View = LDL_view360;
_logic = (createGroup (createCenter sideLogic)) createUnit ["LOGIC", [0, 0, 0], [], 0, ""];
_display = (finddisplay 1000);
_ac130_cam_target = (createGroup (createCenter sideLogic)) createUnit ["LOGIC", [0,0,0], [], 0, ""];

_setCirclePosition =
{
	(_this select 0) setPosASL [(getPos LDL_cam_rotating_center select 0)+sin(LDL_cam_rotating_angle)*(_this select 1),(getPos LDL_cam_rotating_center select 1)+cos(LDL_cam_rotating_angle)*(_this select 1), LDL_cam_rotating_height];	
};

_setSphericPosition =
{
	(_this select 0) setPosASL [(getPosASL (_this select 1) select 0)+sin(_this select 2)*(sqrt((_this select 4)^2 - ((_this select 4)* cos(_this select 3))^2)),(getPosASL (_this select 1) select 1)+cos(_this select 2)*(sqrt((_this select 4)^2 - ((_this select 4)* cos(_this select 3))^2)),(getPosASL (_this select 1) select 2)+(_this select 4)* cos(_this select 3)];
};

while {LDL_ac130_active && !LDL_ac130_abort} do
{
	sleep 0.001;
	
	//Plane
	[LDL_ac130_plane,LDL_cam_rotating_radius]call _setCirclePosition;
	LDL_ac130_plane setDir (LDL_cam_rotating_angle - 90);
	
	if(LDL_flyMode != 3) then //if the plane is not flying to another position
	{
		//rotate plane & camera around the center
		LDL_cam_rotating_angle = [LDL_cam_rotating_angle - LDL_cam_rotating_deg]call LDL_normalizeAngle;
		[LDL_ac130_plane,0,-15] call LDL_setPitchBank; //bank for the AC130
	};
	
	//Looking
	_xM = LDL_mousePosition select 0;
	_yM = LDL_mousePosition select 1;
	_difh = [(LDL_cam_dirh + _xM*1.5 - LDL_cam_rotating_angle)]call LDL_normalizeAngle;
	_difv = [LDL_cam_dirv + _yM*1.5 - 180]call LDL_normalizeAngle;
	(_display displayctrl 1007) ctrlSetTextColor [1,1,1,1];
	LDL_guns_enabled = true;

	if(LDL_viewMode == 0) then
	{
		//interior
		[LDL_ac130_cam,(LDL_cam_rotating_radius-5)]call _setCirclePosition; //camera rotates around the center

		//horizontal
		if((!(_difh < 90) && !(_difh > 270)) || _360View) then
		{
			LDL_cam_dirh = LDL_cam_dirh + _xM*1.5;
		}
		else
		{
			if(_difh < 90) then
			{
				LDL_cam_dirh = [LDL_cam_rotating_angle + 90]call LDL_normalizeAngle;
			}
			else
			{
				LDL_cam_dirh = [LDL_cam_rotating_angle - 90]call LDL_normalizeAngle;
			};
		};
		
		//vertical
		if(!(_difv < 100) && !(_difv > 190)) then
		{
			LDL_cam_dirv = LDL_cam_dirv + _yM*1.5;
		}
		else
		{
			if(_difv > 100) then
			{
				LDL_cam_dirv = 10;
			}
			else
			{
				LDL_cam_dirv = 280;
			};
		};
		
		LDL_cam_dirv = [LDL_cam_dirv]call LDL_normalizeAngle;
		LDL_cam_dirh = [LDL_cam_dirh]call LDL_normalizeAngle;
		
		[_ac130_cam_target,LDL_ac130_cam,LDL_cam_dirh,90 - LDL_cam_dirv,5000]call _setSphericPosition; //camera target
	}
	else
	{
		//exterior
		[_ac130_cam_target,(LDL_cam_rotating_radius-50)]call _setCirclePosition; //camera target rotates around the center
		[LDL_gunPosition,(LDL_cam_rotating_radius-5)]call _setCirclePosition; //position from where the AC130 shoots

		_difv = [LDL_cam_dirv + _yM*1.5 - 180]call LDL_normalizeAngle;
		_logic setPos (screenToWorld [0.5,0.5]);
		_angles = [LDL_gunPosition,_logic]call LDL_getObjectAngles;
		LDL_guns_dirh = [_angles select 0]call LDL_normalizeAngle;
		LDL_guns_dirv = [_angles select 1]call LDL_normalizeAngle;
		
		//vertical
		if(!(_difv < 80) && !(_difv > 179)) then
		{
			LDL_cam_dirv = LDL_cam_dirv + _yM*1.5;
		}
		else
		{
			if(_difv < 80) then
			{
				LDL_cam_dirv = 260;
			}
			else
			{
				LDL_cam_dirv = 359;
			};
		};
		
		//horizontal
		LDL_cam_dirh = LDL_cam_dirh + _xM*1.5;
		
		LDL_cam_dirv = [LDL_cam_dirv]call LDL_normalizeAngle;
		LDL_cam_dirh = [LDL_cam_dirh]call LDL_normalizeAngle;
		
		[LDL_ac130_cam,_ac130_cam_target,LDL_cam_dirh - 180,90 + LDL_cam_dirv,120]call _setSphericPosition;
				
		//guns
		_difh = [(LDL_guns_dirh - LDL_cam_rotating_angle)]call LDL_normalizeAngle;
		_difv = [LDL_guns_dirv - 180]call LDL_normalizeAngle;
		
		if(_difh < 90 || _difh > 270 || _difv < 100 || _difv > 190) then
		{
			(_display displayctrl 1007) ctrlSetTextColor [1,1,1,0];
			LDL_guns_enabled = false;
		};
	};
	
	//commit camera changes	
	LDL_ac130_cam camSetTarget _ac130_cam_target;
	LDL_ac130_cam camSetFov LDL_camFov;
	LDL_ac130_cam camCommit 0;
};

