//AC130-Script by LurchiDerLurch uav_start

private ["_radius","_height","_aboveSeaLevel","_munition_25mm","_munition_40mm","_munition_105mm","_showSignal","_enableHud","_enableFlir","_contrast","_360View","_useNVG","_typeOfNVG","_type","_dialog","_uav_pilot","_uav_copilot","_uav_loadmaster","_showWaypoints","_showParticles","_enablePhysics","_cam","_setCirclePosition"];

//Below are some options you can set:
//********//
_radius = 900; //radius for the AC130; default: ~700
_height = 1000; //start-height for the AC130; default: ~700
_aboveSeaLevel = true; // height is above sea level and not above ground, AC130 will not automaticly correct height; default true 
_munition_25mm = 1000; //Munition for the 25mm; default: 2000
_munition_40mm = 50; //Munition for the 40mm; default: 100
_munition_105mm = 20; //Munition for the 105mm; default: 30
_showSignal = true; //Show signal for friendly units; default: true
_enableHud = true; //Show vehicles as a square; default: true
_enableFlir = true; //Flir; default: true
_contrast = 0.1; //Contrast of flir; default: 0.1
_360View = false; //360 view (UAV) or limited on the left side of the aircraft (AC130); default: false
_useNVG = false; //Use night vision googles; default: false
_typeOfNVG = 0; //Which type of night vision googles, 0 = green, 1 = grey; default: 0
_showWaypoints = true; //Show waypoints; default: true
_showParticles = true; //Show particles (smoke, tracer etc.); default: true
_enablePhysics = true; //Enable physics for the plane. Disabling it avoids instability of the rotating plane (takes no affect on camera); default: true
_maxZoom_25mm = 9.5; //Maximum zoom level for 25mm; default: 9.5 (only numbers between 1 and 10)
_maxZoom_40mm = 9; //Maximum zoom level for 40mm; default: 9 (only numbers between 1 and 10)
_maxZoom_105mm = 8; //Maximum zoom level for 105mm; default: 8 (only numbers between 1 and 10)
//********//

_type = _this select 0;

_setCirclePosition =
{
	(_this select 0) setPosASL [(getPos LDL_cam_rotating_center select 0)+sin(LDL_cam_rotating_angle)*(_this select 1),(getPos LDL_cam_rotating_center select 1)+cos(LDL_cam_rotating_angle)*(_this select 1), LDL_cam_rotating_height];	
};

LDL_uav_type = _type;
LDL_ac130_active = true;
LDL_plane_type = "UAV";

_variables = [_radius,_height,_aboveSeaLevel,_munition_25mm,_munition_40mm,_munition_105mm,_showSignal,_enableHud,_enableFlir,_contrast,_360View,_useNVG,_typeOfNVG,_showWaypoints,_showParticles,_maxZoom_25mm,_maxZoom_40mm,_maxZoom_105mm];

switch(_type) do
{
	case 0:
	{
		//The script creates a UAV at a mapclick position
		//this addAction ["Call UAV", "ac130\UAV\uav_action_map.sqf"];
		
		onMapSingleClick {};
				
		sleep 0.1;
						
		_pos = _this select 1;
		
		LDL_cam_rotating_center setPos _pos;
		LDL_uav_cam_target setPos _pos;
		LDL_uav_plane = createVehicle ["MQ9PredatorB",[getPos player select 0,getPos player select 1,1000], [], 0, "FLY"];
		
		_variables call LDL_setVariables;	
				
		_uav_pilot = "USMC_Soldier_Pilot" createUnit [getPos player,createGroup WEST,"LDL_uav_pilot = this; this moveInDriver LDL_uav_plane; this allowDamage false", 0.6, "corporal"];
		[LDL_uav_plane,LDL_cam_rotating_radius]call _setCirclePosition;
		LDL_uav_plane setDir (LDL_cam_rotating_angle - 90);
		
		[]spawn LDL_uav_rot_waypoints;
		
		//camera

		_cam = "camera" camcreate (getPos player);
		_cam cameraeffect ["internal", "back"];
		showCinemaBorder false;
		camUseNVG false;

		_cam camSetPos (LDL_uav_plane modelToWorld [-30,0,0]);
		_cam camSetTarget LDL_uav_plane;
		_cam camCommit 3;
		
		[_cam]spawn
		{
			
			_setCirclePosition =
			{
				(_this select 0) setPosASL [(getPos LDL_cam_rotating_center select 0)+sin(LDL_cam_rotating_angle)*(_this select 1),(getPos LDL_cam_rotating_center select 1)+cos(LDL_cam_rotating_angle)*(_this select 1), LDL_cam_rotating_height];	
			};
			
			_cam = _this select 0;
			
			for [{_i=0},{_i < 90},{_i = _i + 1}] do
			{
				sleep 0.002;
				[LDL_uav_plane,LDL_cam_rotating_radius]call _setCirclePosition;
				LDL_uav_plane setDir (LDL_cam_rotating_angle - 90);
				LDL_cam_rotating_angle = [LDL_cam_rotating_angle - 0.1]call LDL_normalizeAngle;
				[LDL_uav_plane,0,-15] call LDL_setPitchBank; //bank for the uav	
				
				if(camCommitted _cam) exitWith{};
			};	
		};
		
		_cam camPrepareFov 0.01; 
		_cam camCommitPrepared 2;
		
		titleText ["", "BLACK OUT",2];
		
		waitUntil{sleep 0.1;(camCommitted _cam)};
		
		camDestroy _cam;
		_cam cameraeffect ["terminate", "back"];
		
		titleText ["", "BLACK IN",1];
		
		//camera end
		
		LDL_uav_plane engineOn true;
		
		if(!_enablePhysics) then
		{
			[]spawn 
			{
				sleep 3;
				LDL_uav_plane enableSimulation false;
			};
		};
		
		LDL_flyMode = 1;

		//Create the dialog
		_dialog = createDialog "LDL_UAVDialog";

		//Create the cam
		LDL_uav_cam = []call LDL_createCam;

		//Start all scripts
		[]spawn LDL_uav_rot_camera;
		[]spawn LDL_uav_rot_main;
		[]spawn LDL_ac130_blink;
		[]spawn LDL_ac130_troops;
		[]spawn LDL_ac130_sound;
	};
};

disableSerialization;
	
_display = (finddisplay  1000);

//Info Left
if(LDL_showFlir) then
{
	(_display displayctrl 1017) ctrlSetTextColor [1,0,0,1];
};

if(LDL_useNVG) then
{
	(_display displayctrl 1018) ctrlSetTextColor [1,0,0,1];
};

if(LDL_showBlink) then
{
	(_display displayctrl 1019) ctrlSetTextColor [1,0,0,1];
};

if(LDL_showTroops) then
{
	(_display displayctrl 1020) ctrlSetTextColor [1,0,0,1];
};

if(LDL_showWaypoints) then
{
	(_display displayctrl 1021) ctrlSetTextColor [1,0,0,1];
};
