//init.sqf for Lurchi's AC-130 Script

//Call LDL_init for Lurchi's AC-130 Script
LDL_init = compile preprocessFileLineNumbers "ac130\LDL_init.sqf";
[]spawn LDL_init;
waitUntil {!isNil "LDL_initDone"};
waitUntil {LDL_initDone};

//Examples for Lurchi's AC-130 Script

//1. AC-130 rotates around a center

//1.1 This line will create an AC-130 at player's position which will circle with a radius of 1000m and in a height of 1000m. 
//[getPos player, 1000, 1000, true]call LDL_ac130_rot_setup;

//1.2 This line will force an existing plane named Plane to rotate.
//[Plane, 1000, 1000, true]call LDL_ac130_rot_setup;

//General: [vehicle or position, radius, height, camera approach plane]


//2. Move in camera view of an existing plane

//2.2 This line will put the player into the camera view of his own vehicle. Altitude is 1000m (this takes no effect yet).
//[vehicle player,1000]call LDL_ac130_att_setup;

//General: [vehicle, height]


//3. Creates an AI controlled AC-130 (same code as in 1 but another function)

//3.1 This line will create an AC-130 at player's position which will circle with a radius of 1000m and in a height of 1000m for 180 seconds. (AI controlled)
//[getPos player, 1000, 1000, 180]call LDL_ac130_AI_setup;

//3.2 This line will force an existing plane named Plane to rotate. (AI controlled)
//[Plane, 1000, 1000, 180]call LDL_ac130_AI_setup;

//General: [vehicle or position, radius, height, time]


//4. Action Menus. Put these lines into the init-line of an object

//4.1 Call a rotating AC-130 via mapclick 
//this addAction ["Call AC-130", "ac130\ac130_action_map.sqf"];

//4.2 Call an AI controlled AC-130 via mapclick
//this addAction ["Call AC-130 (AI)", "ac130\ac130_action_map_AI.sqf"];